//+------------------------------------------------------------------+
//|                              COPYRIGHT                           |
//|               YOU SHOULD USE YOUR OWN COPYRIGHT HERE             |
//+------------------------------------------------------------------+
#property copyright "Kevin Lynch"
//+------------------------------------------------------------------+
//|                        COMMON DECLARATION                        |
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+

//#include <TrailingAlls.mqh>

bool EnterLong = false;
bool ExitLong  = false;
bool EnterShort = false;
bool ExitShort = false;
double top = 0,bottom = 0, recenttop = 0, recentbottom = 0;
//+------------------------------------------------------------------+
//|                          EXPERT COLORS                           |
//|            ADJUST THESE VALUES TO MATCH REQUIREMENTS             |
//+------------------------------------------------------------------+
//---- This is the name that will appear on the chart if the expert 
//---- is attached
static string      ExpertName = "Infinity";
//---- Enter Long Color
static color   EnterLongColor = Green;
//---- Enter Short Color
static color  EnterShortColor = Red;
//---- Exit Long Color
static color    ExitLongColor = Blue;
//---- Exit Short Color
static color   ExitShortColor = Pink;
//---- If using pending orders and if you need an expiration enter the value here


//+------------------------------------------------------------------+
//|                          EXPERT ID                               |
//+------------------------------------------------------------------+
// You need to give a unique id to each one of your expert
// This will be used as the magic number and then keep track of 
// the orders generated by the expert. 

//---- The expert ID has to be a 2 digit number followed by 0000
//---- For example: 550000 or 120000 etc ...
static int ExpertID = 630000;

//+------------------------------------------------------------------+
//|                           USER INPUT                             |
//|            ADJUST THESE VALUES TO MATCH REQUIREMENTS             |
//+------------------------------------------------------------------+
//|                Trading Inputs/Indicators Inputs                  |
//+------------------------------------------------------------------+
// If you do not need to use one of these inputs simply comment it out
// For example:
extern int PeriodBeginTime = 0000;
extern int PeriodEndTime = 0130;
extern int PendingOrderEnd = 0800;
extern int OpenOrderEnd = 2000;
extern int PendingMode = 1;
extern int BuyTrigger = 29;
extern int SellTrigger = -20;
extern bool TakeProfitMode = true;
extern int T2 = 175;
extern int T1 = 50;
extern bool StopLossMode = true;
extern int StopLoss = 30;
extern bool BounceMode = false;
extern bool MAMode = true;
extern int MAType = 2;
extern int MAPeriod = 5;
extern bool ATRMode = true;
extern int ATRPeriod = 14;
extern int ATRLevel = 25;
extern double Lots = 5;

extern int Slippage = 2;
extern double TrailingStop = 20;
extern double PercentageToClose = 97;
bool modifyorder = false;
bool TimeSpecific = false;
bool NewOrder = false;
bool ordermodify = false;
int _BuyTicket = 0, _SellTicket = 0, _BuyStopTicket = 0;
int _SellStopTicket = 0, _BuyLimitTicket = 0, _SellLimitTicket = 0;
 
double _BuyLots = 0.0, _SellLots = 0.0, _BuyStopLots = 0.0; 
double _SellStopLots = 0.0, _BuyLimitLots = 0.0, 
_SellLimitLots = 0.0;
 
double _BuyOpenPrice = 0.0, _SellOpenPrice = 0.0, 
_BuyStopOpenPrice = 0.0;
double _SellStopOpenPrice = 0.0, _BuyLimitOpenPrice = 0.0, 
_SellLimitOpenPrice = 0.0;
 
double _BuyStopLoss = 0.0, _SellStopLoss = 0.0, _BuyStopStopLoss = 0.0;
double _SellStopStopLoss = 0.0, _BuyLimitStopLoss = 0.0, _SellLimitStopLoss = 0.0;
 
double _BuyTakeProfit = 0.0, _SellTakeProfit = 0.0, 
_BuyStopTakeProfit = 0.0;
double _SellStopTakeProfit = 0.0, _BuyLimitTakeProfit = 0.0,
 _SellLimitTakeProfit = 0.0;
 
datetime _BuyOpenTime = -1, _SellOpenTime = -1, 
_BuyStopOpenTime = -1;
datetime _SellStopOpenTime = -1, _BuyLimitOpenTime = -1, 
_SellLimitOpenTime = -1;
 
double _BuyProfit = 0.0, _SellProfit = 0.0, _BuySwap = 0.0, 
_SellSwap = 0.0;
double _BuyCommission = 0.0, _SellCommission = 0.0;
 
string _BuyComment = "", _SellComment = "", _BuyStopComment = ""; 
string _SellStopComment = "", _BuyLimitComment = "", 
_SellLimitComment = "";
 
datetime _BuyStopExpiration = -1, _SellStopExpiration = -1;
datetime _BuyLimitExpiration = -1, _SellLimitExpiration = -1;



//+------------------------------------------------------------------+
//|                    EXPERT BASIC INITIALISATION                   |
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+
int start()
  {
  int profit;
 double stoptrade;
 double stopcal;
 int trade;
  string day[7]={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
  int MagicNumber = 0;
     MagicNumber = MakeMagicNumber( ExpertID, TimeSpecific );
     
     
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
 OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
 
 if (OrderMagicNumber()==MagicNumber && OrderLots()==(Lots-(Lots*PercentageToClose/100)))
 

     TrailingAlls(0,TrailingStop, MagicNumber);
     } 
     
//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+  


int _GetLastError = 0;
 
    //---- Memorize parameters of open positions (if available)
    OneTypeOrdersInit( MagicNumber );
 
    //---- If we have both pending orders, quit, 
    //---- we have to wait until one of them triggers
    if ( _BuyStopTicket > 0 && _SellStopTicket > 0 ) return(0);
 
    //---- if there is an open BUY position,
    if ( _BuyTicket > 0 )
    {
        //---- if the SellStop has not been deleted yet, delete it:
        if ( _SellStopTicket > 0 )
        {
            if ( !OrderDelete( _SellStopTicket ) )
            {
                Alert( "OrderDelete Error #", GetLastError() );
                return(-1);
            }//if
        }//if
        //---- check whether the StopLoss should be moved:
        //---- if the Trailing Stop size is not too small,
        if ( T1 > MarketInfo( Symbol(), 
             MODE_STOPLEVEL ) && modifyorder == true || ordermodify==true)
        {
//---- if the profit on the position exceeds TrailingStop points,
            if ( NormalizeDouble( Bid - _BuyOpenPrice, Digits ) >= 
                  NormalizeDouble( T1*Point, Digits ) )
            {
            _BuyStopLoss=NormalizeDouble(Bid-T1*Point,Digits);
                    
                    //---- modify the order
                    if (modifyorder)
                    {
                    if ( !OrderModify( _BuyTicket, _BuyOpenPrice, 
                         Bid-T1*Point, 
                          _BuyTakeProfit, 0,Green ) )                         
                         
                    {
                        Alert( "OrderModify Error #", 
                               GetLastError() );
                               modifyorder=false;
                        return(-1);
                    }//if
                    modifyorder=false;
                    }//if
                    if( ordermodify==true)
                    {
                    OrderClose( _BuyTicket,Lots*PercentageToClose/100,Bid,Slippage,Red);
                   ordermodify=false;
                    
                    
                    }//if
                    else if (TrailingStop == 0)
                    modifyorder=false;
                    
                                   
            }//if
        }//if
//---- if there is an open position, quit, there is nothing to do
      
            else if ((Bid-TrailingStop)>=_BuyOpenPrice)
  {
   profit=NormalizeDouble((Bid-_BuyOpenPrice)/Point,0);
   
   stoptrade=_BuyStopLoss;
   stopcal=Bid-(0*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
   if ( !OrderModify( _BuyTicket, _BuyOpenPrice, 
                         stopcal, 
                          _BuyTakeProfit, 0,Green ) )                         
                         
                    {
                        Alert( "OrderModify Error #", 
                               GetLastError() );
                               
                        return(-1);
                    }//if
                    }//else if
    
  
  
        return(0);
    }//if
 
//---- The block below is absolutely similar to that processing 
//     the BUY position,
//---- this is why we do not comment on it...
    if ( _SellTicket > 0 )
    {
        if ( _BuyStopTicket > 0 )
        {
            if ( !OrderDelete( _BuyStopTicket ) )
            {
                Alert( "OrderDelete Error #", GetLastError() );
                return(-1);
            }
        }
        if(T1 > MarketInfo( Symbol(), MODE_STOPLEVEL) && modifyorder == true || ordermodify==true)
        {
            if(NormalizeDouble( _SellOpenPrice - Ask, Digits ) >= 
                 NormalizeDouble( T1*Point, Digits ) )
            {
                if(NormalizeDouble( Ask + T1*Point, 
                   Digits ) < _SellStopLoss
                      || _SellStopLoss <= 0.0 )
                {
                if (modifyorder)
                    {
                     
                    if(!OrderModify( _SellTicket, _SellOpenPrice, 
                       OrderOpenPrice(), 
                       _SellTakeProfit, 0 ) )
                    {
                        Alert( "OrderModify Error #", 
                               GetLastError() );
                               modifyorder=false;
                        return(-1);
                    }
                      modifyorder=false;
                      }
                    if( ordermodify==true)
                    {
                    OrderClose( _SellTicket,Lots*PercentageToClose/100,Ask,Slippage,Red);
                   ordermodify=false;
                    //_BuyStopLoss=NormalizeDouble(Bid-T1*Point,Digits);
                    
                    }
                    else if (TrailingStop == 0)
                     modifyorder=false;
                }                    
            }
        }
        return(0);
    }



//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+     
     
     
     EnterLong = false;
     ExitLong  = false;
     EnterShort = false;
     ExitShort = false;
     bool ATRGood = false;
     bool MALong = false;
     bool MAShort = false;
     
//+------------------------------------------------------------------+
//|                    EXPERT BASIC CALCULATION                      |
//|                          START HERE                              |
//+------------------------------------------------------------------+
double bid, ask, testlong=0, testshort = 0, testlong1 =0, testshort1=0;
//double top,bottom, bid, ask, testlong=0, testshort = 0;


int PeriodBeginHour=ConvertHour(PeriodBeginTime);
int PeriodBeginMinute=ConvertMinute(PeriodBeginTime);
int PeriodEndHour=ConvertHour(PeriodEndTime);
int PeriodEndMinute=ConvertMinute(PeriodEndTime);
int PendingOrderHour=ConvertHour(PendingOrderEnd);
int PendingOrderMinute=ConvertMinute(PendingOrderEnd);
int OpenOrderHour=ConvertHour(OpenOrderEnd);
int OpenOrderMinute=ConvertMinute(OpenOrderEnd);




if(TimeHour(TimeLocal()) == PeriodEndHour && TimeMinute(TimeLocal()) == PeriodEndMinute)
//if(TimeHour(TimeLocal()) == 5 && TimeMinute(TimeLocal()) == 30)
{
Comment(" Trade day: " , day[DayOfWeek()]);
int BarHours=PeriodEndHour-PeriodBeginHour;
int BarMinutes=PeriodEndMinute-PeriodBeginMinute;
int TestBars=(BarHours*4)+(BarMinutes/15);

top=High[iHighest(NULL,15,MODE_HIGH,TestBars,1)];
bottom=Low[iLowest(NULL,15,MODE_LOW,TestBars,1)];

//top=High[iHighest(NULL,15,MODE_HIGH,6,1)];
//bottom=Low[iLowest(NULL,15,MODE_LOW,6,1)];
NewOrder=true;
}
/*if(((TimeHour(TimeLocal()) >= PeriodEndHour && TimeMinute(TimeLocal()) >= PeriodEndMinute) 
   || TimeHour(TimeLocal())>PeriodEndHour) && (TimeHour(TimeLocal())<PendingOrderHour 
   || TimeHour(TimeLocal())<=PendingOrderHour && TimeHour(TimeLocal())<=PendingOrderMinute)) 

{
*/
if((TimeHour(TimeLocal()) >= PeriodEndHour && TimeMinute(TimeLocal()) >= PeriodEndMinute) 
   || TimeHour(TimeLocal())>PeriodEndHour)
   {
double ATR=iATR(NULL,0,ATRPeriod,0)*100;
double MA=iMA(NULL,0,MAPeriod,0,MAType,PRICE_CLOSE,0);
double MA1=iMA(NULL,0,MAPeriod,0,MAType,PRICE_CLOSE,1);

if (ATRMode)
{
if (ATR>=ATRLevel)
ATRGood=true;
}
else if (!ATRMode)
ATRGood=true;

if (MAMode)
{
if (MA>top && MA1<top)
MALong=true;
else if (MA<bottom && MA1>bottom)
MAShort=true;
}
else if (!MAMode)
{
MALong=true;
MAShort=true;
}


if (Ask>=top+BuyTrigger*Point && MALong && ATRGood)
EnterLong=true;
else if (Bid<=bottom+SellTrigger*Point && MAShort && ATRGood)
EnterShort=true;

if (TimeHour(TimeLocal())==PendingOrderHour && TimeHour(TimeLocal())==PendingOrderMinute)
NewOrder=false;

//+------------------------------------------------------------------+
//|                    EXPERT BASIC CALCULATION                      |
//|                          END HERE                                |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+

// ENTER LONG CONDITION
if(CountLongs(MagicNumber)== 0 && EnterLong==true && NewOrder== true)
{
if (!BounceMode)
{
  if (TakeProfitMode)
  { 
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(bottom),TakeLong(T2),ExpertName,MagicNumber,0,EnterLongColor);
  
Alert("took buy");
NewOrder=false;   
modifyorder = true;
ordermodify = true;
}//if (TakeProfitMode)
else OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(bottom),TakeLong(T1),ExpertName,MagicNumber,0,EnterLongColor);
}//if (!BounceMode)
else if (BounceMode)
{
if (TakeProfitMode)
  { 
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(bottom),TakeLong(T2),ExpertName,MagicNumber,0,EnterLongColor);
  
Alert("took buy");
NewOrder=false;   
modifyorder = true;
ordermodify = true;
}//if (TakeProfitMode)
else OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(bottom),TakeLong(T1),ExpertName,MagicNumber,0,EnterLongColor);
}//else if (BounceMode)
} //if(CountLongs(MagicNumber)== 0 && EnterLong==true && NewOrder== true)
if(CountShorts(MagicNumber)== 0 && EnterShort==true && NewOrder==true)
{ 
if (TakeProfitMode)
  { 

OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShort(top),TakeShort(T2),ExpertName,MagicNumber,0,EnterShortColor);  
Alert("took sell");
NewOrder=false;
modifyorder = true;
ordermodify = true;
}//if (TakeProfitMode)
else OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShort(top),TakeShort(T1),ExpertName,MagicNumber,0,EnterShortColor);  
} //if(CountShorts(MagicNumber)== 0 && EnterShort==true && NewOrder==true)
}
//OrderSelect(_BuyTicket,SELECT_BY_TICKET);
OneTypeOrdersInit( MagicNumber );
//OrderModify(_BuyTicket,OrderOpenPrice(),0,0,0,Red);

if (TimeHour(TimeLocal())==PendingOrderHour && TimeHour(TimeLocal())==PendingOrderMinute)
NewOrder=false;
if (TimeHour(TimeLocal()) == OpenOrderHour && TimeHour(TimeLocal()) == OpenOrderMinute)
closeorder(MagicNumber);

   return(0);
 }
//+------------------------------------------------------------------+
//|                     EXTERNAL FUNCTIONS                           |
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Make Magic Number                                                |
//+------------------------------------------------------------------+
int MakeMagicNumber( int ExpertID, bool TimeSpecific )
{
   int SymbolCode  = 0;
   int PeriodCode  = 0;
   int MagicNumber = 0; 
   
   //---- Symbol Code
        if( Symbol() == "AUDCAD" || Symbol() == "AUDCADm" ) { SymbolCode = 1000; }
   else if( Symbol() == "AUDJPY" || Symbol() == "AUDJPYm" ) { SymbolCode = 2000; }
   else if( Symbol() == "AUDNZD" || Symbol() == "AUDNZDm" ) { SymbolCode = 3000; }
   else if( Symbol() == "AUDUSD" || Symbol() == "AUDUSDm" ) { SymbolCode = 4000; }
   else if( Symbol() == "CHFJPY" || Symbol() == "CHFJPYm" ) { SymbolCode = 5000; }
   else if( Symbol() == "EURAUD" || Symbol() == "EURAUDm" ) { SymbolCode = 6000; }
   else if( Symbol() == "EURCAD" || Symbol() == "EURCADm" ) { SymbolCode = 7000; }
   else if( Symbol() == "EURCHF" || Symbol() == "EURCHFm" ) { SymbolCode = 8000; }
   else if( Symbol() == "EURGBP" || Symbol() == "EURGBPm" ) { SymbolCode = 9000; }
   else if( Symbol() == "EURJPY" || Symbol() == "EURJPYm" ) { SymbolCode = 1000; }
   else if( Symbol() == "EURUSD" || Symbol() == "EURUSDm" ) { SymbolCode = 1100; }
   else if( Symbol() == "GBPCHF" || Symbol() == "GBPCHFm" ) { SymbolCode = 1200; }
   else if( Symbol() == "GBPJPY" || Symbol() == "GBPJPYm" ) { SymbolCode = 1300; }
   else if( Symbol() == "GBPUSD" || Symbol() == "GBPUSDm" ) { SymbolCode = 1400; }
   else if( Symbol() == "NZDJPY" || Symbol() == "NZDJPYm" ) { SymbolCode = 1500; }
   else if( Symbol() == "NZDUSD" || Symbol() == "NZDUSDm" ) { SymbolCode = 1600; }
   else if( Symbol() == "USDCAD" || Symbol() == "USDCADm" ) { SymbolCode = 1700; }
   else if( Symbol() == "USDCHF" || Symbol() == "USDCHFm" ) { SymbolCode = 1800; }
   else if( Symbol() == "USDJPY" || Symbol() == "USDJPYm" ) { SymbolCode = 1900; }
                     
   
   //---- Period Code
   if( TimeSpecific )
   {
              if( Period() == 1 )    { PeriodCode = 10; }
         else if( Period() == 5 )    { PeriodCode = 20; }
         else if( Period() == 15 )   { PeriodCode = 30; }
         else if( Period() == 30 )   { PeriodCode = 40; }
         else if( Period() == 60 )   { PeriodCode = 50; }
         else if( Period() == 240 )  { PeriodCode = 60; }
         else if( Period() == 1440 ) { PeriodCode = 70; }
         else if( Period() == 10080 ){ PeriodCode = 80; }
   }
   else
   {
      PeriodCode = 0;
   }
   //---- Calculate MagicNumber
   MagicNumber = ExpertID+SymbolCode+PeriodCode;
   return(MagicNumber);
}

//+------------------------------------------------------------------+
//| Calculate Stop Long                                              |
//+------------------------------------------------------------------+
double StopLong(double bottom)
{
if (StopLossMode)
  return(bottom+(1*Point));
  else if (!StopLossMode)
  {
  if (StopLoss == 0)return(0);
  else return(Bid-StopLoss*Point);
 }
}
//+------------------------------------------------------------------+
//| Calculate Stop Short                                             |
//+------------------------------------------------------------------+
double StopShort(double top)
{
 if (StopLossMode)
  return(top-(1*Point));
  else if (!StopLossMode)
  {
  if (StopLoss == 0)return(0);
  else return(Ask+StopLoss*Point);
  }
}
//+------------------------------------------------------------------+
//| Calculate Profit Target Long                                     |
//+------------------------------------------------------------------+
double TakeLong(int target)
{
if (target == 0) return(0);
else   return(Ask+(target*Point));
}
//+------------------------------------------------------------------+
//| Calculate Profit Target Short                                     |
//+------------------------------------------------------------------+
double TakeShort(int target)
{
  if (target == 0) return(0);
else   return(Bid-(target*Point));
}
//+------------------------------------------------------------------+
//| Calculate concurrent Long position                               |
//+------------------------------------------------------------------+
int CountLongs(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if( OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber )
   continue;
   
  if(OrderType()==OP_BUYSTOP)
   count++;
 }//for
 return(count);
}
//+------------------------------------------------------------------+
//| Calculate concurrent short position                              |
//+------------------------------------------------------------------+
int CountShorts(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber )
   continue;
   
  if(OrderType()==OP_SELLSTOP)
  count++;
 }//for
 return(count);
}

//+------------------------------------------------------------------+
//| Calculates Trailing Stops                                        |
//+------------------------------------------------------------------+

void OneTypeOrdersInit( int magic )
{
// zeroizing of variables:
    _BuyTicket = 0; _SellTicket = 0; _BuyStopTicket = 0;
    _SellStopTicket = 0; _BuyLimitTicket = 0; _SellLimitTicket = 0;
 
    _BuyLots = 0.0; _SellLots = 0.0; _BuyStopLots = 0.0; 
    _SellStopLots = 0.0; _BuyLimitLots = 0.0; _SellLimitLots = 0.0;
 
    _BuyOpenPrice = 0.0; _SellOpenPrice = 0.0; _BuyStopOpenPrice = 0.0;
    _SellStopOpenPrice = 0.0; _BuyLimitOpenPrice = 0.0; 
_SellLimitOpenPrice = 0.0;
 
    _BuyStopLoss = 0.0; _SellStopLoss = 0.0; _BuyStopStopLoss = 0.0;
    _SellStopStopLoss = 0.0; _BuyLimitStopLoss = 0.0; 
_SellLimitStopLoss = 0.0;
 
    _BuyTakeProfit = 0.0; _SellTakeProfit = 0.0; 
_BuyStopTakeProfit = 0.0;
    _SellStopTakeProfit = 0.0; _BuyLimitTakeProfit = 0.0; 
_SellLimitTakeProfit = 0.0;
 
    _BuyOpenTime = -1; _SellOpenTime = -1; _BuyStopOpenTime = -1;
    _SellStopOpenTime = -1; _BuyLimitOpenTime = -1; 
_SellLimitOpenTime = -1;
 
    _BuyProfit = 0.0; _SellProfit = 0.0; _BuySwap = 0.0; 
_SellSwap = 0.0;
    _BuyCommission = 0.0; _SellCommission = 0.0;
 
    _BuyComment = ""; _SellComment = ""; _BuyStopComment = ""; 
    _SellStopComment = ""; _BuyLimitComment = ""; 
_SellLimitComment = "";
 
    _BuyStopExpiration = -1; _SellStopExpiration = -1;
    _BuyLimitExpiration = -1; _SellLimitExpiration = -1;
 
    int _GetLastError = 0, _OrdersTotal = OrdersTotal();
    for ( int z = _OrdersTotal - 1; z >= 0; z -- )
    {
        if ( !OrderSelect( z, SELECT_BY_POS ) )
        {
          _GetLastError = GetLastError();
          Print("OrderSelect(", z, ",SELECT_BY_POS) - Error #", 
                _GetLastError );
          continue;
        }
        if ( OrderMagicNumber() == magic && OrderSymbol() == 
            Symbol() )
        {
          switch ( OrderType() )
          {
            case OP_BUY:
             _BuyTicket     = OrderTicket();
             _BuyLots       = NormalizeDouble( OrderLots(), 1 );
             _BuyOpenPrice  = NormalizeDouble( OrderOpenPrice(),
                                               Digits );
             _BuyStopLoss   = NormalizeDouble( OrderStopLoss(), 
                                               Digits );
             _BuyTakeProfit = NormalizeDouble( OrderTakeProfit(),
                                               Digits );
             _BuyOpenTime   = OrderOpenTime();
             _BuyProfit     = NormalizeDouble( OrderProfit(), 2 );
             _BuySwap       = NormalizeDouble( OrderSwap(), 2 );
             _BuyCommission = NormalizeDouble( OrderCommission(),
                                               2 );
             _BuyComment    = OrderComment();
             break;
           case OP_SELL:
             _SellTicket     = OrderTicket();
             _SellLots       = NormalizeDouble( OrderLots(), 1 );
             _SellOpenPrice  = NormalizeDouble( OrderOpenPrice(),
                                                Digits );
             _SellStopLoss   = NormalizeDouble( OrderStopLoss(),
                                                Digits );
             _SellTakeProfit = NormalizeDouble( OrderTakeProfit(),
                                                Digits );
             _SellOpenTime   = OrderOpenTime();
             _SellProfit     = NormalizeDouble( OrderProfit(), 2 );
             _SellSwap       = NormalizeDouble( OrderSwap(), 2 );
             _SellCommission = NormalizeDouble( OrderCommission(),
                                                2 );
             _SellComment    = OrderComment();
             break;
           case OP_BUYSTOP:
             _BuyStopTicket     = OrderTicket();
             _BuyStopLots       = NormalizeDouble( OrderLots(), 1 );
             _BuyStopOpenPrice  = NormalizeDouble( OrderOpenPrice(),
                                                   Digits );
             _BuyStopStopLoss   = NormalizeDouble( OrderStopLoss(),
                                                   Digits );
             _BuyStopTakeProfit = NormalizeDouble( OrderTakeProfit(),
                                                   Digits );
             _BuyStopOpenTime   = OrderOpenTime();
             _BuyStopComment    = OrderComment();
             _BuyStopExpiration = OrderExpiration();
             break;
          case OP_SELLSTOP:
             _SellStopTicket     = OrderTicket();
             _SellStopLots       = NormalizeDouble( OrderLots(), 1 );
             _SellStopOpenPrice  = NormalizeDouble( OrderOpenPrice(),
                                                    Digits );
             _SellStopStopLoss   = NormalizeDouble( OrderStopLoss(),
                                                    Digits );
             _SellStopTakeProfit = NormalizeDouble( OrderTakeProfit(),
                                                    Digits );
             _SellStopOpenTime   = OrderOpenTime();
             _SellStopComment    = OrderComment();
             _SellStopExpiration = OrderExpiration();
             break;
          case OP_BUYLIMIT:
             _BuyLimitTicket     = OrderTicket();
             _BuyLimitLots       = NormalizeDouble( OrderLots(), 1 );
             _BuyLimitOpenPrice  = NormalizeDouble( OrderOpenPrice(),
                                                    Digits );
             _BuyLimitStopLoss   = NormalizeDouble( OrderStopLoss(),
                                                    Digits );
             _BuyLimitTakeProfit = NormalizeDouble( OrderTakeProfit(),
                                                    Digits );
             _BuyLimitOpenTime   = OrderOpenTime();
             _BuyLimitComment    = OrderComment();
             _BuyLimitExpiration = OrderExpiration();
             break;
           case OP_SELLLIMIT:
             _SellLimitTicket     = OrderTicket();
             _SellLimitLots       = NormalizeDouble( OrderLots(), 1 );
             _SellLimitOpenPrice  = NormalizeDouble( OrderOpenPrice(),
                                                     Digits );
             _SellLimitStopLoss   = NormalizeDouble( OrderStopLoss(),
                                                     Digits );
             _SellLimitTakeProfit = NormalizeDouble( OrderTakeProfit(),
                                                     Digits );
             _SellLimitOpenTime   = OrderOpenTime();
             _SellLimitComment    = OrderComment();
             _SellLimitExpiration = OrderExpiration();
             break;
            }
        }
    }
}


void closeorder(int MagicNumber)
{
int order=0;
int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if( OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber )
   continue;
if (OrderType()==OP_BUY)
{
order = OrderTicket();
OrderClose(order,Lots,Bid,Slippage,Red);

}

else if (OrderType()==OP_SELL)
{
order = OrderTicket();
OrderClose(order,Lots,Ask,Slippage,Red);
}
}
return;
}


int ConvertHour(int time)
{
int hour=0;
hour = MathRound(time/100);
return (hour);
}

int ConvertMinute(int time)
{
int hour=0;
int minute=0;
hour = MathRound(time/100);
minute=time-(hour*100);
return (minute);
}

void TrailingAlls(int start,int stop, int magicnumber)
{
Alert(Symbol());
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0) return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol() || OrderMagicNumber()!= magicnumber)
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Green);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Green);
  }//Shrt
  
 }//for
}





